;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; featherweight.tf
;;
;; Script that uses sqlite to track 'best weight' on featherweighted items.
;;
;; You will need to change the path in the FWDBFILE and FWSCRIPTFILE variables
;; to reflect your setup.  You will also need to change 'Hair' to your
;; name.  This script relies on trigging on "emote weigh <x>" using your
;; merchant toolbelt.  In 'Section 2' below are some trigs and hooks that
;; will automatically wear your toolbelt when the spell is started and
;; when the spell is cast successfully.  You will need to change the line
;; referencing the girdle of etheral power to whatever belt you'll probably
;; be wearing while doing fws.  The hook allows you to just 'fw <x>' it works
;; just like a BatMUD command-alias.

/SET FWDBFILE=/home/hair/tf-dir/featherweight.db

/SET FWSCRIPTFILE=/home/hair/tf-dir/sqlite -separator '#'

/DEF -mregexp -t"\*Hair \:([ ]*)([0-9.]*) (.*)\.$" get_eq_name_and_weight = \
	/LET _eqWeight=%{P2} %; \
	/LET _eqName=%{P3} %; \
	/IF (regmatch(" (labeled as|\(glowing\)|\<([a-z]*) glow\>)", %{_eqName})) \
		/LET _eqName=%{PL} %; \
	/ENDIF %; \
	/LET _bestWeight=$(/search_eq_in_file %{_eqWeight} %{_eqName}) %; \
	/ECHO -aBCwhite BEST WEIGHT: %{_bestWeight}

/DEF -i search_eq_in_file = \
	/LET _sql=select * from ITEMS where NAME like \\"%{-1}\\"; %; \
	/LET _eqFull=$(/QUOTE -S /ECHO !bash %{FWSCRIPTFILE} %{FWDBFILE} "%{_sql}") %; \
	/IF (regmatch("([0-9]*)#(.*)#([0-9.]*)", %{_eqFull})) \
		/IF (%{1} < %{P3}) \
			/LET _sql=update ITEMS set WEIGHT = %{1} where NAME like \\"%{-1}\\"; %; \
			/QUOTE -S /ECHO !bash %{FWSCRIPTFILE} %{FWDBFILE} "%{_sql}" %; \
			/LET _result=%{1} %; \
		/ELSE \
			/LET _result=%{P3} %; \
		/ENDIF %; \
	/ELSE \
		/LET _sql=insert into ITEMS (NAME,WEIGHT) values (\\"%{-1}\\",%{1}); %; \
		/SYS %{FWSCRIPTFILE} %{FWDBFILE} "%{_sql}" %; \
		/LET _result=%{1} %; \
	/ENDIF %; \
	/RESULT %{_result}

;;;;;;;;; Section 2
/DEF -p100 -ag -i -h"send {fw}*" spl_feather_weight = \
        /SET cast_status=FW %; \
        /IF (%{-1} !~ "") \
                /spl_feather_weight2 %{-1} %; \
        /ELSE /ECHO This spell requires a target %; \
                /SET cast_status= %; \
        /ENDIF

/DEF spl_feather_weight2 = \
        /SEND @cast feather weight at %{*} %; \
        /SEND @wear replacing toolbelt %; \
        /SEND @quote 'weigh %{*}' emote %; \
        /SEND @wear replacing Girdle of Ethereal Power labeled as <spr><...H> %; \
        /DEF -n1 -t"You cast the spell successfully." spl_feather_weight3 = \
                /SEND @wear replacing toolbelt %%; \
                /SEND @quote 'weigh %{*}' emote %%; \
                /SEND @wear replacing Girdle of Ethereal Power labeled as <spr><...H>

/DEF -F -i -t"You enhance the feather weight." spl_feather_weight_enhanced = \
        /SEND @say Enhanced the feather weight!

/DEF -F -i -t"You feel that the spell will last for*" spl_feather_weight_report = \
        /SEND @say FW should last for: %{-8}

/DEF -F -i -t"You reset the feather weight." spl_feather_weight_reset = \
        /SEND @say Reset feather weight.


