#!/usr/bin/perl

use strict;
use warnings;
#############################################
#
# fwimport.pl
#
#############################################
# change the values of $dbfile to the absolute path to your
# own database file and do the same for $dbcommand to the
# absolute path to your sqlite3 executable
#
# ALSO!  Be sure to change the path variables in the
# featherweight.tf script

my $dbfile="/home/hair/tf-dir/featherweight.db";
my $dbcommand="/usr/bin/sqlite3 -separator '#'";
my $charname="Hair";

print ("WARNING: This could take some time to run depending on how many/how large\n");
print ("log files you are parsing through.  Hit Ctrl-C now to abort.\n");
print ("This script will search the given directory for all files ending with '.log'\n");
print ("and search through them for any output from the merchant toolbelt 'weigh'\n");
print ("command that has been emoted.  Output should look similar to the following:\n");
print ("*Hair :   3.743 Blackened half-plate (glowing) <orange glow>.\n");
print ("Be sure to change the \$charname variable in the script to your own name.\n");
print ("Enter path to log files: ");
my $outputdir = <STDIN>;
chop($outputdir);
opendir(LOGDIR, "$outputdir") or die("Unable to open log directory.\n");
my @ulogdir = grep(/(.*)log/,readdir(LOGDIR));
my @logdir = sort (@ulogdir);
my $file = undef;

print ("Starting import...\n");
foreach $file (@logdir) {
	open (LOG, "<$outputdir/$file") or die("Unable to open $file\n");
	print ("Processing file $outputdir/$file\n");
	while (<LOG>) {
		if ($_ =~ m/^\*$charname \:([ ]*)([0-9.]*) (.*)\.$/ ) {
			my $_eqWeight = $2;
			my $_eqName = rtrim($3);
			if ($_eqName =~ m/(.*)labeled as(.*)/ ) {
				$_eqName = rtrim($1);
			} elsif ($_eqName =~ m/(.*)\(glowing\)(.*)/ ) {
				$_eqName = rtrim($1);
			} elsif ($_eqName =~ m/(.*)\<([a-z]*) glow\>(.*)/ ) {
				$_eqName = rtrim($1);
			}
			my $sql = "\"select * from ITEMS where NAME like \\\"$_eqName\\\";\"";
			my $result = qx/$dbcommand $dbfile $sql/;
			if ($result ne "") {
				my @fields = split(/\#/, $result);
				my $_lWeight = $fields[2];
				if ($_eqWeight < $_lWeight) {
					my $sql = "\"update ITEMS set WEIGHT = $_eqWeight where NAME = \\\"$_eqName\\\";\"";
					system("$dbcommand $dbfile $sql");
				}
			}
			else {
				my $sql = "\"insert into ITEMS (NAME,WEIGHT) values (\\\"$_eqName\\\",$_eqWeight);\"";
				system("$dbcommand $dbfile $sql");
			}
		}
	}
}
closedir(LOGDIR);
print ("Import complete.\n");

sub rtrim { my $s = shift; $s =~ s/\s+$//;       return $s };

