#!/usr/bin/perl

use strict;
use warnings;

#############################################
# change the values of $dbfile to the absolute path to your
# own database file and do the same for $dbcommand to the
# absolute path to your sqlite3 executable
#
# ALSO!  Be sure to change the path variables in the
# featherweight.tf script
#
# ONLY use this script if you want to start with a blank
# database.  Be sure to remove or rename 'featherweight.db'
# that is included with this package

my $dbfile="/home/hair/tf-dir/featherweight.db";
my $dbcommand="/usr/bin/sqlite3";

print ("Creating blank database: $dbfile\n");
system ("touch $dbfile");
print ("Creating empty tables...\n");
my $sql="\"create table ITEMS(ID INTEGER PRIMARY KEY AUTOINCREMENT,NAME TEXT NOT NULL,WEIGHT FLOAT NOT NULL);\"";
system ("$dbcommand $dbfile $sql");
my $sql="\"create index ITEMINDEX on ITEMS (NAME)\";";
system ("$dbcommand $dbfile $sql");
print ("\nDatabase initialization complete\n");

